# Hekili

## [v8.1.0-10](https://github.com/Hekili/hekili/tree/v8.1.0-10) (2019-01-24)
[Full Changelog](https://github.com/Hekili/hekili/compare/v8.1.0-10-beta3...v8.1.0-10)

- Enhancement:  Add some flexibility with ST/AOE swaps and weapon buffs for Freezerburn build.  
- Buffs:  Fix stack overflow in buff uptime/duration.  
    Core/State:  
    - Fix GCD order vs. cast order for predictions.  
    - Move reset after debug init so I can dump debug info from reset into snapshots.  
    - Fix channels.  
- Classes:  Split handlers into cast start, cast finish, spell impact where applicable.  
    - Add isProjectile flag to abiliites with an onImpact handler.  
    - Track which spells are castable while casting.  
    - Add strictTiming aura flag to ignore buffPadding.  
    - Flag variable action as essential so it gets processed as needed.  
    - Move runHandler to state:RunHandler.  
    State:  Clean up ability history tracking.  
    - Only treat attackable targets as bosses.  
    - Update in\_flight; add in\_flight\_remains and executing for spell queue system.  
    - target.casting now just checks for the casting debuff.  
    - Add query functions for real aura data (just PlayerHasBuff, TargetHasDebuff and the like, for now).  
    - Even queue system, a bit too inefficient right now but only used by Fire Mage.  
    - Clean-up spellcast detection on resets.  
    - state:StartCombat() now available (for impacts).  
    - Flow control actions are not impacted by casting.  
    Core:  For specs that can cast while casting, queue these actions and test for recommendations before casting is completed or projectiles impact.  
    Events:  Work on responsiveness to combat events, localize some table functions.  
    UI:  ForceUpdate moved to UI.lua.  
    Powers:  Use token names for variants (i.e., natural\_harmony\_x).  
- Fire Mage:  Work on projectile/cast while casting.  
    Mages:  Get RoP duration from totem API.  
- Enhancement:  Trigger Natural Harmony from attacks.  
- Feral:  Update APL with ShmooDude's adjustments.  
- Enhancement:  Update APL for new builds.  
- Protection Warrior:  Ignore Pain is a defensive ability.  (Having Shield Block shown in Defensives and Ignore Pain in Primary was misleading).  
- Core:  Allow predictions to be checked within a constrained range (i.e., to see if we recommend something before or after a projectile will hit).  
- Unholy:  Add Necrotic Strike, Necrotic Wound.  
    - Treat "Raise Abomination" as a replacement for Army of the Dead (and its CD).  
    - Register Gargoyle and Abomination as totems.  
- Addon:  Fix Development vs. build ID.  
- Aura Handling:  Scrape player/target aura data on next UNIT\_AURA after a SPELL\_AURA\_x event.  
- State:  Remove expired projectiles properly.  
- UI:  Use separators in dropdown menu.  
- State:  Correct variable name for estimated impact.  
- Feral:  Fix Moment of Clarity/Clearcasting multiplier.  
- Frost, Unholy:  Correct Dark Succor spell ID.  
- State:  Update InFlight system to prepare for projectile rechecks.  
- Events:  Move spells\_in\_flight to State (InFlight).  
- Feral:  Clean up unused data.  
